/* cache.h */

#define MAX_CACHE_SIZE 2*1024*1024
#define HASH_SIZE 273

#define hash_function(x) ((x)%(HASH_SIZE))

#undef LEASE_DEBUG 


/* isso so' funciona se o printk so' tem um parametro:

#ifdef	LEASE_DEBUG
#   define PRINTK(x)	printk x
#else
#   define PRINTK(x)	abre e fecha comentario
#endif
*/

#ifdef	LEASE_DEBUG
#   define PRINTK	printk 
#else
#   define PRINTK	if (0) printk
#endif


int printk(const char * fmt, ...);


struct hash_table_entry{}; /* prototype */


struct list_node {
  	struct hash_table_entry *file;  /* the file that owns this block */
  	char *data;			/* pointer to data block */
	unsigned long offset; 		/* offset of the file where this */
                                        /* block begins. */
	unsigned long size;		/* block size */

	struct list_node *offset_prev, /* doubly linked list of blocks */
			 *offset_next; /* sorted by offset             */
	
	struct list_node *LRU_prev,    /* LRU queue (doubly linked list of blocks) */
			 *LRU_next;
};


struct hash_table_entry {
  	unsigned long inode_number;	/* inode->i_ino */
        char *hostname;			/* NFS_SERVER(inode)->hostname */
        unsigned long lease_expiration; /* lease expiration timestamp */
	unsigned int seconds,useconds;  /* modification time */
	struct list_node *offset_list;
	struct hash_table_entry *colision_next,
				*colision_prev;
};
	







