#include"cache.h"
#include"structures.h"
#include<time.h>

extern struct hash_table_entry cache_table[HASH_SIZE];
extern struct list_node *LRU;
extern unsigned long cache_current_size;
extern int sys_time(void *);

void print_cache_info(void)
{
 int i,time;
 struct hash_table_entry *file;
 struct list_node *block;

 printk("***** CACHE STATE (BEGIN) ***(total size: %d bytes)*******\n",
	cache_current_size);

 for(i = 0; i < HASH_SIZE; i++)
   {
     for(file = &cache_table[i]; file; file = file->colision_next)
       if (file->hostname)
	 {
           if((time = file->lease_expiration - sys_time(NULL)) > 0)
	     {
	       printk("host:%s inode:%ld cache_table[%d] lease expires in %d seconds\n",
		      file->hostname,file->inode_number,i,time);
	     }
	   else
	     {
	       printk("host:%s inode:%ld cache_table[%d] lease expired\n",
		      file->hostname,file->inode_number,i,
		      file->lease_expiration - sys_time(NULL));
	     }
	   for(block = file->offset_list; block; block = block->offset_next)
	       printk("inode: %ld offset: %ld size: %d stored at %X\n",
		      file->inode_number, block->offset, 
		      block->size, block->data);
	 }
   }
 printk("***** CACHE STATE (END) ****(total size: %d bytes)*******\n",
	cache_current_size);

}/* print_cache_info */


void print_hash_line(int line)
{
  struct hash_table_entry *file;
  
  for(file = &cache_table[line]; file; file = file->colision_next)
    if (file->hostname)
      printk("host: %s inode: %ld cache_table[%d] @ %X\n",
	     file->hostname,file->inode_number,line,file);
}/* print_hash_line */


void print_LRU_queue(void)
{
  struct list_node *block;

  printk("******** LRU queue ********\n");
  for(block = LRU; block; block = block->LRU_prev)
    printk("host: %s inode: %ld offset: %ld size: %ld\n", block->file->hostname,
	   block->file->inode_number, block->offset, block->size);
}/* print_LRU_queue */


void clear_cache(void)
{
 int i;
 struct hash_table_entry *file;
 
 printk("************** LIMPANDO O CACHE ******************\n ");
 for(i = 0; i < HASH_SIZE; i++)
   for(file = &cache_table[i]; file; file = cache_table[i].colision_next)
     if (file->hostname)
	 clear_file_cache(file);

}/* clear_cache */







